/**
 * IMP Folders Javascript
 *
 * Provides the javascript to help the folders.php script.
 * This file should be included via Horde::addScriptFile().
 *
 * See the enclosed file COPYING for license information (GPL). If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 *
 * $Horde: imp/js/src/folders.js,v 1.4 2007/09/25 12:33:42 slusarz Exp $
 */

function getChecked()
{
    return getFolders().findAll(function(e) {
        return e.checked;
    });
}

function getFolders()
{
    return Form.getInputs('fmanager', null, 'folder_list[]');
}

function selectedFoldersDisplay()
{
    var folder = 0, sel = "";
    getFolders().each(function(e) {
        if (e.checked) {
            sel += displayNames[folder] + "\n";
        }
        ++folder;
    });

    if (sel.charAt(sel.length - 1) == "\n") {
        sel = sel.substring(0, sel.length - 1);
    }

    return sel;
}

function chooseAction(e)
{
    var id = (Event.element(e).id == 'action_choose0') ? 0 : 1;

    var a = $('action_choose' + id);
    var action = a.options[a.selectedIndex].value;
    a.selectedIndex = 0;

    if (action == 'create_folder') {
        createMailbox();
    } else if (action == 'rebuild_tree') {
        submitAction(action);
    } else if (getChecked().length == 0) {
        if (action != '') {
            alert(ImpText.folders_select);
        }
    } else if (action == 'rename_folder') {
        renameMailbox();
    } else if (action == 'subscribe_folder' ||
               action == 'unsubscribe_folder' ||
               action == 'poll_folder' ||
               action == 'expunge_folder' ||
               action == 'nopoll_folder' ||
               action == 'mark_folder_seen' ||
               action == 'mark_folder_unseen' ||
               action == 'delete_folder_confirm' ||
               action == 'folders_empty_mailbox_confirm' ||
               action == 'mbox_size') {
        submitAction(action);
    } else if (action == 'download_folder' ||
               action == 'download_folder_zip') {
        downloadMailbox(action);
    } else if (action == 'import_mbox') {
        if (getChecked().length > 1) {
            alert(ImpText.folders_oneselect);
        } else {
            submitAction(action);
        }
    }
}

function submitAction(a)
{
    $('actionID').value = a;
    $('fmanager').submit();
}

function createMailbox()
{
    var count = getChecked().length, mbox;
    if (count > 1) {
        window.alert(ImpText.folders_oneselect);
        return;
    }

    if (count == 1) {
        mbox = window.prompt(ImpText.folders_subfolder1 + ' ' + selectedFoldersDisplay() + ".\n" + ImpText.folders_subfolder2 + "\n", '');
    } else {
        mbox = window.prompt(ImpText.folders_toplevel, '');
    }

    if (mbox) {
        $('new_mailbox').value = mbox;
        submitAction('create_folder');
    }
}

function downloadMailbox(actionid)
{
    if (window.confirm(ImpText.folders_download1 + "\n" + selectedFoldersDisplay() + "\n" + ImpText.folders_download2)) {
        submitAction(actionid);
    }
}

function renameMailbox()
{
    var newnames = '', oldnames = '', j = 0;

    getFolders().each(function(f) {
        if (f.checked) {
            if (ImpVar.fixed_folders.indexOf(displayNames[j]) != -1) {
                window.alert(ImpText.folders_no_rename + ' ' + displayNames[j]);
            } else {
                var tmp = window.prompt(ImpText.folders_rename1 + ' ' + displayNames[j] + "\n" + ImpText.folders_rename2, displayNames[j]);
                if (tmp) {
                    newnames += tmp + "\n";
                    oldnames += f.value + "\n";
                }
            }
        }
        ++j;
    });

    if (!newnames) {
        return;
    }

    if (newnames.charAt(newnames.length - 1) == "\n") {
        newnames = newnames.substring(0, newnames.length - 1);
    }
    if (oldnames.charAt(oldnames.length - 1) == "\n") {
        oldnames = oldnames.substring(0, oldnames.length - 1);
    }

    $('new_names').value = newnames;
    $('old_names').value = oldnames;
    submitAction('rename_folder');
    return true;
}

function toggleSelection()
{
    var count = getChecked().length, folders = getFolders();
    var checked = (count != folders.length);
    folders.each(function(f) {
        f.checked = checked;
    });
}

Event.observe(window, 'load', function() {
    if ($('checkAll')) {
        Event.observe('checkAll', 'click', toggleSelection);
        Event.observe('action_choose0', 'change', chooseAction);
        Event.observe('action_choose1', 'change', chooseAction);
    }
});
